#
# encoding: UTF-8
# api: python
# type: functions
# title: json emulation
# description: simplify usage of some gtk widgets
# version: 1.5
# author: mario
# license: public domain
#
#
#  This module provides the JSON api. If the python 2.6 module
#  isn't available, it provides an emulation using str() and
#  eval() and Python notation. (The representations are close.)
#


#-- reading and writing json (for the config module)  ----------------------------------


# try to load the system module first
try:
    from json import dump, load
    #print "real json module"


except:
    # pseudo-JSON implementation
    # - the basic python data types dict,list,str,int are mostly identical to json
    # - therefore a basic str() conversion is enough for writing
    # - for reading the more bothersome eval() is used
    # - it's however no severe security problem here, because we're just reading
    #   local config files (written by us) and accept no data from outside / web
    # NOTE: This code is only used, if the Python json module (since 2.6) isn't there.
    def dump(fp, obj):
        return fp.write(str(obj))  # .replace("'}, ", "'},\n ") slows down and might corrupt the data ( unwanted whitespace)
        pass      #   .replace("', ", "',\n "))   .replace("': [{'", "':\n[\n{'")

    def load(fp):
        return eval(fp.read(1<<27))   # max 128 MB
    #print "fake json module"
